//
// DO NOT EDIT THIS FILE.Generated using AndroidAnnotations 3.3.2.
//  You can create a larger work that contains this file and distribute that work under terms of your choice.
//


package org.transdroid.core.widget;

import java.util.List;
import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.os.Build.VERSION;
import android.os.Build.VERSION_CODES;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.support.v4.app.ActivityCompat;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.CheckBox;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import org.androidannotations.api.BackgroundExecutor;
import org.androidannotations.api.SdkVersionHelper;
import org.androidannotations.api.builder.ActivityIntentBuilder;
import org.androidannotations.api.view.HasViews;
import org.androidannotations.api.view.OnViewChangedListener;
import org.androidannotations.api.view.OnViewChangedNotifier;
import org.transdroid.R.layout;
import org.transdroid.core.app.settings.ApplicationSettings_;
import org.transdroid.core.app.settings.ServerSetting;
import org.transdroid.core.app.settings.SystemSettings_;
import org.transdroid.core.gui.lists.SortByListItem;
import org.transdroid.core.gui.log.Log_;
import org.transdroid.core.gui.navigation.StatusType.StatusTypeFilter;
import org.transdroid.core.service.ConnectivityHelper_;
import org.transdroid.daemon.Label;
import org.transdroid.daemon.Torrent;

@TargetApi(11)
public final class ListWidgetConfigActivity_
    extends ListWidgetConfigActivity
    implements HasViews, OnViewChangedListener
{

    private final OnViewChangedNotifier onViewChangedNotifier_ = new OnViewChangedNotifier();
    private Handler handler_ = new Handler(Looper.getMainLooper());

    @Override
    public void onCreate(Bundle savedInstanceState) {
        OnViewChangedNotifier previousNotifier = OnViewChangedNotifier.replaceNotifier(onViewChangedNotifier_);
        init_(savedInstanceState);
        super.onCreate(savedInstanceState);
        OnViewChangedNotifier.replaceNotifier(previousNotifier);
        setContentView(layout.activity_widgetconfig);
    }

    private void init_(Bundle savedInstanceState) {
        OnViewChangedNotifier.registerOnViewChangedListener(this);
        systemSettings = SystemSettings_.getInstance_(this);
        connectivityHelper = ConnectivityHelper_.getInstance_(this);
        applicationSettings = ApplicationSettings_.getInstance_(this);
        log = Log_.getInstance_(this);
    }

    @Override
    public void setContentView(int layoutResID) {
        super.setContentView(layoutResID);
        onViewChangedNotifier_.notifyViewChanged(this);
    }

    @Override
    public void setContentView(View view, LayoutParams params) {
        super.setContentView(view, params);
        onViewChangedNotifier_.notifyViewChanged(this);
    }

    @Override
    public void setContentView(View view) {
        super.setContentView(view);
        onViewChangedNotifier_.notifyViewChanged(this);
    }

    public static ListWidgetConfigActivity_.IntentBuilder_ intent(Context context) {
        return new ListWidgetConfigActivity_.IntentBuilder_(context);
    }

    public static ListWidgetConfigActivity_.IntentBuilder_ intent(android.app.Fragment fragment) {
        return new ListWidgetConfigActivity_.IntentBuilder_(fragment);
    }

    public static ListWidgetConfigActivity_.IntentBuilder_ intent(android.support.v4.app.Fragment supportFragment) {
        return new ListWidgetConfigActivity_.IntentBuilder_(supportFragment);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (((SdkVersionHelper.getSdkInt()< 5)&&(keyCode == KeyEvent.KEYCODE_BACK))&&(event.getRepeatCount() == 0)) {
            onBackPressed();
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void onViewChanged(HasViews hasViews) {
        serverSpinner = ((Spinner) hasViews.findViewById(org.transdroid.R.id.server_spinner));
        darkthemeCheckBox = ((CheckBox) hasViews.findViewById(org.transdroid.R.id.darktheme_check_box));
        downspeedText = ((TextView) hasViews.findViewById(org.transdroid.R.id.downspeed_text));
        downcountSign = ((TextView) hasViews.findViewById(org.transdroid.R.id.downcount_sign));
        reverseorderCheckBox = ((CheckBox) hasViews.findViewById(org.transdroid.R.id.reverseorder_check_box));
        serverstatusView = hasViews.findViewById(org.transdroid.R.id.serverstatus_view);
        sortSpinner = ((Spinner) hasViews.findViewById(org.transdroid.R.id.sort_spinner));
        filterText = ((TextView) hasViews.findViewById(org.transdroid.R.id.filter_text));
        filterSpinner = ((Spinner) hasViews.findViewById(org.transdroid.R.id.filter_spinner));
        serverText = ((TextView) hasViews.findViewById(org.transdroid.R.id.server_text));
        errorText = ((TextView) hasViews.findViewById(org.transdroid.R.id.error_text));
        torrentsList = ((ListView) hasViews.findViewById(org.transdroid.R.id.torrents_list));
        upcountText = ((TextView) hasViews.findViewById(org.transdroid.R.id.upcount_text));
        showstatusCheckBox = ((CheckBox) hasViews.findViewById(org.transdroid.R.id.showstatus_check_box));
        upcountSign = ((TextView) hasViews.findViewById(org.transdroid.R.id.upcount_sign));
        navigationView = hasViews.findViewById(org.transdroid.R.id.navigation_view);
        upspeedText = ((TextView) hasViews.findViewById(org.transdroid.R.id.upspeed_text));
        downcountText = ((TextView) hasViews.findViewById(org.transdroid.R.id.downcount_text));
        if (serverSpinner!= null) {
            serverSpinner.setOnItemSelectedListener(new OnItemSelectedListener() {


                @Override
                public void onNothingSelected(AdapterView<?> parent) {
                    ListWidgetConfigActivity_.this.serverSpinnerItemSelected(false, null);
                }

                @Override
                public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                    ListWidgetConfigActivity_.this.serverSpinnerItemSelected(true, ((ServerSetting) parent.getAdapter().getItem(position)));
                }

            }
            );
        }
        if (sortSpinner!= null) {
            sortSpinner.setOnItemSelectedListener(new OnItemSelectedListener() {


                @Override
                public void onNothingSelected(AdapterView<?> parent) {
                    ListWidgetConfigActivity_.this.sortSpinnerItemSelected(false, null);
                }

                @Override
                public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                    ListWidgetConfigActivity_.this.sortSpinnerItemSelected(true, ((SortByListItem) parent.getAdapter().getItem(position)));
                }

            }
            );
        }
        if (filterSpinner!= null) {
            filterSpinner.setOnItemSelectedListener(new OnItemSelectedListener() {


                @Override
                public void onNothingSelected(AdapterView<?> parent) {
                    ListWidgetConfigActivity_.this.filterSpinnerItemSelected(false, null);
                }

                @Override
                public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                    ListWidgetConfigActivity_.this.filterSpinnerItemSelected(true, ((StatusTypeFilter) parent.getAdapter().getItem(position)));
                }

            }
            );
        }
        init();
    }

    @Override
    public void showError(final boolean emptyResults) {
        handler_.post(new Runnable() {


            @Override
            public void run() {
                ListWidgetConfigActivity_.super.showError(emptyResults);
            }

        }
        );
    }

    @Override
    public void onTorrentsRetrieved(final List<Torrent> torrents, final List<Label> labels) {
        handler_.post(new Runnable() {


            @Override
            public void run() {
                ListWidgetConfigActivity_.super.onTorrentsRetrieved(torrents, labels);
            }

        }
        );
    }

    @Override
    public void loadTorrents() {
        BackgroundExecutor.execute(new BackgroundExecutor.Task("", 0, "") {


            @Override
            public void execute() {
                try {
                    ListWidgetConfigActivity_.super.loadTorrents();
                } catch (Throwable e) {
                    Thread.getDefaultUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), e);
                }
            }

        }
        );
    }

    public static class IntentBuilder_
        extends ActivityIntentBuilder<ListWidgetConfigActivity_.IntentBuilder_>
    {

        private android.app.Fragment fragment_;
        private android.support.v4.app.Fragment fragmentSupport_;

        public IntentBuilder_(Context context) {
            super(context, ListWidgetConfigActivity_.class);
        }

        public IntentBuilder_(android.app.Fragment fragment) {
            super(fragment.getActivity(), ListWidgetConfigActivity_.class);
            fragment_ = fragment;
        }

        public IntentBuilder_(android.support.v4.app.Fragment fragment) {
            super(fragment.getActivity(), ListWidgetConfigActivity_.class);
            fragmentSupport_ = fragment;
        }

        @Override
        public void startForResult(int requestCode) {
            if (fragmentSupport_!= null) {
                fragmentSupport_.startActivityForResult(intent, requestCode);
            } else {
                if (fragment_!= null) {
                    if (VERSION.SDK_INT >= VERSION_CODES.JELLY_BEAN) {
                        fragment_.startActivityForResult(intent, requestCode, lastOptions);
                    } else {
                        fragment_.startActivityForResult(intent, requestCode);
                    }
                } else {
                    if (context instanceof Activity) {
                        Activity activity = ((Activity) context);
                        ActivityCompat.startActivityForResult(activity, intent, requestCode, lastOptions);
                    } else {
                        if (VERSION.SDK_INT >= VERSION_CODES.JELLY_BEAN) {
                            context.startActivity(intent, lastOptions);
                        } else {
                            context.startActivity(intent);
                        }
                    }
                }
            }
        }

    }

}
